-- name: [PET] Bup
-- description: Bup!

if not _G.wpets then return end

-- Utility function to generate the info for pet initialization
local function set_info(data, model)
	local info = {
		modelID 	= model,
		name 		= data.name 		or "Pet name",
		description = data.description 	or "Pet description.",
		credit 		= data.credit 		or "Saul",
		flying 		= data.flying 		or false,
		scale 		= data.scale 		or 1.0,
		yOffset 	= data.yOffset 		or 0,
	}

	for i, set in ipairs(data) do
		for key, value in pairs(set) do
			info[key] = value
		end
	end
	
	return info
end

local function create_pet(data, models, type, sounds)
	-- Load models from string array
	for i in ipairs(models) do
		models[i] = smlua_model_util_get_id(models[i])
	end
	
	-- Generate pet info and create pet
	local ID_PET = _G.wpets.add_pet(set_info(data, models[1]))

	-- Add alternate models for the pet, if there's more than 1 model
	if #models > 1 then
		for i in ipairs(models) do
			if i > 1 then
				_G.wpets.add_pet_alt(ID_PET, models[i])
			end
		end
	end

	_G.wpets["set_pet_anims_" .. type](ID_PET)

	if (sounds) then
		_G.wpets.set_pet_sounds(ID_PET, sounds)
	end

	return ID_PET
end

-- Bup
-- Bup!

create_pet({
	name = "Bup",
	description = "Bup!",
}, {
	'Bup_pet_geo',
}, 'wing', {
	spawn =		{'bup.ogg'},
	happy =		{'bup.ogg'},
	vanish =	{'scream.ogg'},
	step =		{'bup.ogg'}
})
